{-# LANGUAGE ExplicitNamespaces, TypeOperators #-}
module GEODE.Metadata.Record
  ( Record(..) ) where

import GEODE.Metadata.Types (type (@)(..))
import System.FilePath ((</>))
import Text.Printf (printf)

class Record a where
  toUID :: a -> String
  fromUID :: String -> Either String a
  relativePath :: a -> String -> FilePath

instance (Record a, Record b) => Record (a @ b) where
  toUID (a :@: b) = printf "%s_%s" (toUID a) (toUID b)

  fromUID s = do
    prefix <- fromUID s
    (prefix :@:) <$> fromUID (drop (length (toUID prefix) + 1) s)

  relativePath (a :@: b) extension =
    relativePath a "" </> relativePath b extension
